#include <bits/stdc++.h>
using namespace std;
#define fwd(i, a, n) for(int i = (a); i < (n); i++)
#define rep(i, n) fwd(i, 0, n)
#define all(X) X.begin(), X.end()
#define sz(X) int(ssize(X))
#define pb push_back
#define eb emplace_back
#define st first
#define nd second
using pii = pair<int, int>; using vi = vector<int>;
using ll = long long; using ld = long double;
#ifdef LOC
auto SS = signal(6, [](int) {* (int *) 0 = 0;});
#define DTP(x, y) auto operator << (auto& o, auto a) -> decltype(y, o) {o << "("; x; return o << ")";}
DTP(o << a.st << ", " << a.nd, a.nd);
DTP(for(auto i : a) o << i << ", ", all(a));
void dump(auto... x) {((cerr << x << ", "), ...) << "\n";}
#define deb(x...) cerr << setw(4) << __LINE__ << ":[" #x "]: ", dump(x)
#else
#define deb(...) 0
#endif

struct Matching : vi
{
    vector<vi> adj;
    vi rank, low, pos, vis, seen; int k{0};
    Matching(int n = 0) : vi(n, -1), rank(n) {}
    bool add(vi vec) {
        adj.pb(move(vec));
        low.pb(0);
        pos.pb(0);
        vis.pb(0);
        if (!adj.back().empty()) {
            int i = k;
        nxt:
            seen.clear();
            if (dfs(sz(adj)-1, ++k-i)) return 1;
            for (auto v : seen) for (auto e : adj[v])
                if (rank[e] < 1e9 && vis[at(e)] < k)
                    goto nxt;
            for (auto v : seen) for (auto w : adj[v])
                rank[w] = low[v] = 1e9;
        }
        return 0;
    }
    bool dfs(int v, int g) {
        if (vis[v] < k) vis[v] = k, seen.pb(v);
        while (low[v] < g) {
            int e = adj[v][pos[v]];
            if (at(e) != v && low[v] == rank[e]) {
                rank[e]++;
                if (at(e) == -1 || dfs(at(e), rank[e]))
                    return at(e) = v, 1;
            } else if (++pos[v] == sz(adj[v])) {
                pos[v] = 0, low[v]++;
            }
        }
        return 0;
    }
};

void sol() {
    int n;
    cin >> n;
    vector<ll> a(n);
    rep(i, n) cin >> a[i];

    vector<ll> vec;

    for (ll x : a) {
        fwd(i, 1, n+1) {    
            vec.pb(x*i);
        }
    }

    sort(all(vec));
    vec.erase(unique(all(vec)), vec.end());

    vector<vi> prawe(sz(vec));

    rep(id, n) {
        vi when(n+1, 1);
        when[0] = 0;

        for (ll x : a) {
            ll i = x / gcd(x, a[id]);
            if (i <= n) when[i]--;
        }

        int bal = 0;

        fwd(i, 1, n+1) {
            ll x = a[id] * i;
            auto it = lower_bound(all(vec), x);
            int here = int(it - vec.begin());
            prawe[here].pb(id);

            bal += when[i];
            if (bal >= 0) break;
        }
    }

    deb(a);

    rep(i, sz(vec)) deb(i, vec[i], prawe[i]);

    Matching match(n);
    int mat = 0;

    rep(id, sz(vec)) {
        if (prawe[id].empty())
            continue;

        mat += match.add(prawe[id]);
        if (mat == n) {
            cout << vec[id] << '\n';
            return;
        }
    }
    assert(false);
}

int32_t main(){
    cin.tie(0)->sync_with_stdio(0);
    cout << fixed << setprecision(10);

    int z;
    cin >> z;
    while (z--) sol();

    return 0;
}